struct kwine_object
{
    kwine_object_type* type;
    wait_queue_head_t wait;
};

typedef int (*kwine_object_function)(struct winefs_object* obj);
typedef int (*kwine_object_user_function)(struct winefs_object* obj,
					  void* data);

struct kwine_object_type
{
    const char *name; /* must exist unchanged until it's unregistered. */

    kwine_object_user_function construct;
    kwine_object_function destroy;	/* nullable: kfrees object data */

    kwine_object_function wait_try;	/* nullable: assumes always ready */
    kwine_object_function wait_commit;	/* nullable: assumes no-op */
    kwine_object_function wait_abort;	/* nullable: assumes no-op */

    size_t num_user_functions;
    kwine_object_user_function user_functions[0];
};

int kwine_register_object_type(const struct kwine_object_type *type);
void kwine_unregister_object_type(const struct kwine_object_type *type);

struct kwine_controller
{
    const struct kwine_object_type *type;
    void (*delete_inode)(struct inode *);
};
